
import datetime
import uuid

from nsj_rest_lib.decorator.dto import DTO
from nsj_rest_lib.descriptor.dto_field import DTOField
from nsj_rest_lib.descriptor.dto_field_validators import DTOFieldValidators
from nsj_rest_lib.dto.dto_base import DTOBase



# Configuracoes execucao
from nsj_integracao_api_entidades.config import (tenant_is_partition_data)

@DTO()
class ValestransportespersonalizadostrabalhadoreDTO(DTOBase):
    # Atributos da entidade
    id: uuid.UUID = DTOField(
      pk=True,
      entity_field='valetransportepersonalizadotrabalhador',
      resume=True,
      not_null=True,
      strip=True,
      min=36,
      max=36,
      validator=DTOFieldValidators().validate_uuid,)
    tenant: int = DTOField(
      partition_data=tenant_is_partition_data,
      resume=True,
      not_null=True,)
    datainicial: datetime.datetime = DTOField(
      not_null=True,)
    datafinal: datetime.datetime = DTOField(
      not_null=True,)
    tipo: int = DTOField(
      not_null=True,)
    conteudo: int = DTOField(
      not_null=True,)
    trabalhador: uuid.UUID = DTOField(
      strip=True,
      min=36,
      max=36,
      validator=DTOFieldValidators().validate_uuid,)
    lastupdate: datetime.datetime = DTOField()
    situacao: int = DTOField(
      not_null=True,)
    origem: int = DTOField(
      not_null=True,)
    motivo: int = DTOField(
      not_null=True,)
    created_at: datetime.datetime = DTOField()
    created_by: str = DTOField()
    updated_by: str = DTOField()
    justificativa: str = DTOField()
    solicitacao: uuid.UUID = DTOField(
      strip=True,
      min=36,
      max=36,
      validator=DTOFieldValidators().validate_uuid,)

